##function: ec2-instance-data
ec2-instance-data() {
  local ver="latest"
  [ "$2" ] && ver="$2"
  curl --retry 3 --retry-delay 0 --silent --fail "http://169.254.169.254/$ver/$1"
  [ $? -eq 0 ] && echo
}

##function: ec2-meta-data
ec2-meta-data() {
  ec2-instance-data "meta-data/$1" "$2"
}

##function: ec2-instance-id
ec2-instance-id() {
  ec2-meta-data instance-id
}

##function: ec2-public-hostname
ec2-public-hostname() {
  ec2-meta-data public-hostname
}

##function: ec2-public-ip
ec2-public-ip() {
  ec2-meta-data public-ipv4
}

##function: ec2-public-ipv4
ec2-public-ipv4() {
  ec2-public-ip
}
